package cn.ibizlab.core.uaa.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.core.uaa.domain.SYS_ROLE_PERMISSION;
import cn.ibizlab.core.uaa.filter.SYS_ROLE_PERMISSIONSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[SYS_ROLE_PERMISSION] 服务对象接口
 */
public interface ISYS_ROLE_PERMISSIONService extends IService<SYS_ROLE_PERMISSION>{

    SYS_ROLE_PERMISSION get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    SYS_ROLE_PERMISSION getDraft(SYS_ROLE_PERMISSION et) ;
    boolean create(SYS_ROLE_PERMISSION et) ;
    void createBatch(List<SYS_ROLE_PERMISSION> list) ;
    boolean checkKey(SYS_ROLE_PERMISSION et) ;
    boolean save(SYS_ROLE_PERMISSION et) ;
    void saveBatch(List<SYS_ROLE_PERMISSION> list) ;
    boolean update(SYS_ROLE_PERMISSION et) ;
    void updateBatch(List<SYS_ROLE_PERMISSION> list) ;
    Page<SYS_ROLE_PERMISSION> searchDefault(SYS_ROLE_PERMISSIONSearchContext context) ;
    List<SYS_ROLE_PERMISSION> selectByPermissionid(String permissionid) ;
    void removeByPermissionid(String permissionid) ;
    void saveByPermissionid(String permissionid,List<SYS_ROLE_PERMISSION> list) ;
    List<SYS_ROLE_PERMISSION> selectByRoleid(String roleid) ;
    void removeByRoleid(String roleid) ;
    void saveByRoleid(String roleid,List<SYS_ROLE_PERMISSION> list) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


